diff --git a/media/cdm/proxy_decryptor.h b/media/cdm/proxy_decryptor.h
index 8103739..b340670 100644
--- a/media/cdm/proxy_decryptor.h
+++ b/media/cdm/proxy_decryptor.h
@@ -9,11 +9,17 @@
 #include <vector>
 
 #include "base/basictypes.h"
+#if defined(USE_GSTREAMER)
+#include "base/bind.h"
+#endif
 #include "base/containers/hash_tables.h"
 #include "base/memory/scoped_ptr.h"
 #include "base/memory/scoped_vector.h"
 #include "base/memory/weak_ptr.h"
 #include "media/base/cdm_context.h"
+#if defined(USE_GSTREAMER)
+#include "media/base/cdm_key_information.h"
+#endif
 #include "media/base/decryptor.h"
 #include "media/base/eme_constants.h"
 #include "media/base/media_export.h"
@@ -25,6 +31,12 @@ namespace media {
 class CdmFactory;
 class MediaPermission;
 
+#if defined(USE_GSTREAMER)
+MEDIA_EXPORT void IgnoreCdmContextKeysReady(const std::string& session_id,
+                                            bool has_additional_usable_key,
+                                            CdmKeysInfo keys_info);
+#endif
+
 // ProxyDecryptor is for EME v0.1b only. It should not be used for the WD API.
 // A decryptor proxy that creates a real decryptor object on demand and
 // forwards decryptor calls to it.
@@ -37,6 +49,11 @@ class MEDIA_EXPORT ProxyDecryptor {
   // Callback to provide a CdmContext when the CDM creation is finished.
   // If CDM creation failed, |cdm_context| will be null.
   typedef base::Callback<void(CdmContext* cdm_context)> CdmContextReadyCB;
+#if defined(USE_GSTREAMER)
+  typedef base::Callback<void(const std::string& session_id,
+                              bool has_additional_usable_key,
+                              CdmKeysInfo keys_info)> CdmContextKeysReadyCB;
+#endif
 
   // These are similar to the callbacks in media_keys.h, but pass back the
   // session ID rather than the internal session ID.
@@ -61,7 +78,13 @@ class MEDIA_EXPORT ProxyDecryptor {
   void CreateCdm(CdmFactory* cdm_factory,
                  const std::string& key_system,
                  const GURL& security_origin,
+#if defined(USE_GSTREAMER)
+                 const CdmContextReadyCB& cdm_context_ready_cb,
+                 const CdmContextKeysReadyCB& cdm_context_keys_ready_cb =
+                     base::Bind(&IgnoreCdmContextKeysReady));
+#else
                  const CdmContextReadyCB& cdm_context_ready_cb);
+#endif
 
   // May only be called after CreateCDM().
   void GenerateKeyRequest(EmeInitDataType init_data_type,
@@ -138,6 +161,9 @@ class MEDIA_EXPORT ProxyDecryptor {
   KeyAddedCB key_added_cb_;
   KeyErrorCB key_error_cb_;
   KeyMessageCB key_message_cb_;
+#if defined(USE_GSTREAMER)
+  CdmContextKeysReadyCB cdm_context_keys_ready_cb_;
+#endif
 
   std::string key_system_;
   GURL security_origin_;
diff --git a/sandbox/linux/syscall_broker/broker_file_permission.h b/sandbox/linux/syscall_broker/broker_file_permission.h
index 03300d1..c34b618 100644
--- a/sandbox/linux/syscall_broker/broker_file_permission.h
+++ b/sandbox/linux/syscall_broker/broker_file_permission.h
@@ -49,6 +49,17 @@ class SANDBOX_EXPORT BrokerFilePermission {
     return BrokerFilePermission(path, false, true, true, true, true);
   }
 
+#if defined(USE_GSTREAMER)
+  static BrokerFilePermission ReadWriteRecursive(const std::string& path) {
+    return BrokerFilePermission(path, true, false, true, true, false);
+  }
+
+  static BrokerFilePermission ReadWriteCreateRecursive(
+      const std::string& path) {
+    return BrokerFilePermission(path, true, false, true, true, true);
+  }
+#endif
+
   static BrokerFilePermission ReadWriteCreateUnlinkRecursive(
       const std::string& path) {
     return BrokerFilePermission(path, true, true, true, true, true);
@@ -116,4 +127,4 @@ class SANDBOX_EXPORT BrokerFilePermission {
 
 }  // namespace sandbox
 
-#endif  //  SANDBOX_LINUX_SYSCALL_BROKER_BROKER_FILE_PERMISSION_H_
\ No newline at end of file
+#endif  //  SANDBOX_LINUX_SYSCALL_BROKER_BROKER_FILE_PERMISSION_H_
diff --git a/sandbox/linux/syscall_broker/broker_host.cc b/sandbox/linux/syscall_broker/broker_host.cc
index e5957ed..2584d68 100644
--- a/sandbox/linux/syscall_broker/broker_host.cc
+++ b/sandbox/linux/syscall_broker/broker_host.cc
@@ -45,6 +45,16 @@ int sys_open(const char* pathname, int flags) {
   } else {
     mode = 0;
   }
+
+#if defined(USE_GSTREAMER)
+  // FIXME: once media sandbox works with pulseaudio we will be able to check
+  // if the following lines are necessary. Pulseaudio calls shm_open with 0700.
+  // If required we will have to improve broker process 's IPC-COMMAND_OPEN.
+  if (std::string(pathname).find("/dev/shm/pulse-shm-") != std::string::npos) {
+    mode = 0700;
+  }
+#endif
+
   if (IsRunningOnValgrind()) {
     // Valgrind does not support AT_FDCWD, just use libc's open() in this case.
     return open(pathname, flags, mode);
diff --git a/ui/gl/gl_image_egl.cc b/ui/gl/gl_image_egl.cc
index 0ebd7cc..705935d 100644
--- a/ui/gl/gl_image_egl.cc
+++ b/ui/gl/gl_image_egl.cc
@@ -33,6 +33,19 @@ bool GLImageEGL::Initialize(EGLenum target,
     return false;
   }
 
+#if defined(USE_GSTREAMER)
+  dmabuf_fds_.clear();
+  for (size_t i = 0; i < 30; ++i) {
+    if (attrs[i] == EGL_DMA_BUF_PLANE0_FD_EXT ||
+        attrs[i] == EGL_DMA_BUF_PLANE1_FD_EXT ||
+        attrs[i] == EGL_DMA_BUF_PLANE2_FD_EXT) {
+      dmabuf_fds_.push_back(new base::ScopedFD(attrs[i + 1]));
+    } else if (attrs[i] == EGL_NONE) {
+      break;
+    }
+  }
+#endif
+
   return true;
 }
 
diff --git a/ui/gl/gl_image_egl.h b/ui/gl/gl_image_egl.h
index 14cc40b..ffecd97 100644
--- a/ui/gl/gl_image_egl.h
+++ b/ui/gl/gl_image_egl.h
@@ -9,6 +9,11 @@
 #include "ui/gl/gl_bindings.h"
 #include "ui/gl/gl_image.h"
 
+#if defined(USE_GSTREAMER)
+#include "base/files/scoped_file.h"
+#include "base/memory/scoped_vector.h"
+#endif
+
 namespace gfx {
 
 class GL_EXPORT GLImageEGL : public GLImage {
@@ -36,6 +41,12 @@ class GL_EXPORT GLImageEGL : public GLImage {
                             const Rect& bounds_rect,
                             const RectF& crop_rect) override;
 
+#if defined(USE_GSTREAMER)
+  void OnMemoryDump(base::trace_event::ProcessMemoryDump* pmd,
+                    uint64_t process_tracing_id,
+                    const std::string& dump_name) override {}
+#endif
+
  protected:
   ~GLImageEGL() override;
 
@@ -43,6 +54,10 @@ class GL_EXPORT GLImageEGL : public GLImage {
   const gfx::Size size_;
   base::ThreadChecker thread_checker_;
 
+#if defined(USE_GSTREAMER)
+  ScopedVector<base::ScopedFD> dmabuf_fds_;
+#endif
+
  private:
   DISALLOW_COPY_AND_ASSIGN(GLImageEGL);
 };
diff --git a/ui/gl/gl_surface_egl.cc b/ui/gl/gl_surface_egl.cc
index 2e193a5..95bc939 100644
--- a/ui/gl/gl_surface_egl.cc
+++ b/ui/gl/gl_surface_egl.cc
@@ -632,7 +632,12 @@ EGLConfig NativeViewGLSurfaceEGL::GetConfig() {
         return NULL;
       }
 
+#if defined(USE_GSTREAMER)
+      if ((g_config && g_config == config_) ||
+          config_depth == win_attribs.depth) {
+#else
       if (config_depth == win_attribs.depth) {
+#endif
         return config_;
       }
     }
diff --git a/ui/gl/gl_surface_x11.cc b/ui/gl/gl_surface_x11.cc
index 4e14a43..d4a0b93 100644
--- a/ui/gl/gl_surface_x11.cc
+++ b/ui/gl/gl_surface_x11.cc
@@ -329,6 +329,9 @@ scoped_refptr<GLSurface> GLSurface::CreateOffscreenGLSurface(
       return surface;
     }
     case kGLImplementationEGLGLES2: {
+#if defined(USE_GSTREAMER)
+// TODO: if EGL_KHR_surfaceless_context just use surface as EGL_NO_SURFACE.
+#endif
       scoped_refptr<GLSurface> surface(new PbufferGLSurfaceEGL(size));
       if (!surface->Initialize())
         return NULL;
-- 
2.1.0

